searchNodes=[{"doc":"Retreives config values and provides helper methods.","ref":"Bling.html","title":"Bling","type":"behaviour"},{"doc":"","ref":"Bling.html#bling/0","title":"Bling.bling/0","type":"function"},{"doc":"","ref":"Bling.html#c:can_manage_billing?/2","title":"Bling.can_manage_billing?/2","type":"callback"},{"doc":"","ref":"Bling.html#customer_from_stripe_id/1","title":"Bling.customer_from_stripe_id/1","type":"function"},{"doc":"","ref":"Bling.html#customer_type_from_struct/1","title":"Bling.customer_type_from_struct/1","type":"function"},{"doc":"","ref":"Bling.html#customers/0","title":"Bling.customers/0","type":"function"},{"doc":"","ref":"Bling.html#c:handle_stripe_webhook_event/1","title":"Bling.handle_stripe_webhook_event/1","type":"callback"},{"doc":"","ref":"Bling.html#module_from_customer_type/1","title":"Bling.module_from_customer_type/1","type":"function"},{"doc":"","ref":"Bling.html#repo/0","title":"Bling.repo/0","type":"function"},{"doc":"","ref":"Bling.html#subscription/0","title":"Bling.subscription/0","type":"function"},{"doc":"","ref":"Bling.html#subscription_item/0","title":"Bling.subscription_item/0","type":"function"},{"doc":"","ref":"Bling.html#c:tax_rate_ids/1","title":"Bling.tax_rate_ids/1","type":"callback"},{"doc":"","ref":"Bling.html#c:to_stripe_params/1","title":"Bling.to_stripe_params/1","type":"callback"},{"doc":"","ref":"Bling.html#t:conn/0","title":"Bling.conn/0","type":"type"},{"doc":"","ref":"Bling.html#t:customer/0","title":"Bling.customer/0","type":"type"},{"doc":"","ref":"Bling.html#t:event/0","title":"Bling.event/0","type":"type"},{"doc":"Module for interacting with Bling customers. Each method expects the first argument to be an ecto struct.","ref":"Bling.Customers.html","title":"Bling.Customers","type":"module"},{"doc":"Returns the stripe customer for the given database customer.","ref":"Bling.Customers.html#as_stripe_customer/1","title":"Bling.Customers.as_stripe_customer/1","type":"function"},{"doc":"Creates and returns a url to the stripe billing portal. Examples url = billing_portal_url ( customer , stripe : %{ return_url : &quot;http://localhost:4000/users/settings&quot; } } )","ref":"Bling.Customers.html#billing_portal_url/2","title":"Bling.Customers.billing_portal_url/2","type":"function"},{"doc":"Creates a setup intent for the given customer. Defaults to off_session usage. Examples intent = Bling.Customers . create_setup_intent ( current_user ) # Can pass any valid Stripe.SetupIntent.create/1 params. intent = Bling.Customers . create_setup_intent ( current_user , stripe : %{ payment_method_types : [ &quot;card&quot; ] } )","ref":"Bling.Customers.html#create_setup_intent/2","title":"Bling.Customers.create_setup_intent/2","type":"function"},{"doc":"Creates a customer in stripe from the given database customer. If to_stripe_params/1 is present on your Bling module, the map returned there will be merged with the params passed to stripe. Examples # Can pass any valid Stripe.customer.create/1 params. customer = Bling.Customers . create_stripe_customer ( current_user , stripe : %{ name : &quot;Jane Doe&quot; } )","ref":"Bling.Customers.html#create_stripe_customer/2","title":"Bling.Customers.create_stripe_customer/2","type":"function"},{"doc":"Creates a subscription in stripe and stores it in the database. Tries to confirm the payment immediately. If the payment requires further authentication or errors, the subscription will be marked as incomplete and you must use the payment intent to confirm the payment on your frontend. https://stripe.com/docs/billing/subscriptions/overview Examples result = create_subscription ( current_user , return_url : &quot;http://localhost:4000/billing/user/1/finalize&quot; , # the route you configured during installation prices : [ { price_id , quantity } ] , plan : &quot;default&quot; , # can be omitted stripe : %{ coupon : &quot;coupon_id&quot; } , # any valid Stripe.Subscription.create/1 params ) case result do { :ok , subscription } -&gt; # success, db subscription { :requires_action , payment_intent } -&gt; # payment requires further authentication { :error , error } -&gt; # Stripe.Error, card could have been declined end","ref":"Bling.Customers.html#create_subscription/2","title":"Bling.Customers.create_subscription/2","type":"function"},{"doc":"Returns the defauly payment method for a customer, or nil. The payment method returned is a Bling.PaymentMethod struct.","ref":"Bling.Customers.html#default_payment_method/1","title":"Bling.Customers.default_payment_method/1","type":"function"},{"doc":"Returns whether the customer is on a generic trial. Checks the trial_ends_at column on the customer.","ref":"Bling.Customers.html#generic_trial?/1","title":"Bling.Customers.generic_trial?/1","type":"function"},{"doc":"Returns whether the customer has a default payment method.","ref":"Bling.Customers.html#has_default_payment_method?/1","title":"Bling.Customers.has_default_payment_method?/1","type":"function"},{"doc":"Returns all Stripe.Invoice structs for a customer. Examples invoices = invoices ( current_user ) # Can pass any valid Stripe.Invoice.list/1 params. invocies = invoices ( current_user , stripe : %{ limit : 10 } )","ref":"Bling.Customers.html#invoices/2","title":"Bling.Customers.invoices/2","type":"function"},{"doc":"Returns whether or not the customer is subscribed to a plan, and that plan is valid. Examples # checks if the customer is subscribed to the default plan Bling.Customers . subscribed? ( customer ) # checks if the customer is subscribed to a specific plan Bling.Customers . subscribed? ( customer , plan : &quot;pro&quot; )","ref":"Bling.Customers.html#subscribed?/2","title":"Bling.Customers.subscribed?/2","type":"function"},{"doc":"Returns whether or not the customer is subscribed to a specific price and the subscription is valid. Examples # checks if the customer is subscribed to a price on the default plan Bling.Customers . subscribed_to_price? ( customer , &quot;price_123&quot; ) # checks if the customer is subscribed to a price on a specific plan Bling.Customers . subscribed_to_price? ( customer , &quot;price_123&quot; , plan : &quot;pro&quot; )","ref":"Bling.Customers.html#subscribed_to_price?/3","title":"Bling.Customers.subscribed_to_price?/3","type":"function"},{"doc":"Returns whether or not the customer is subscribed to a specific product and the subscription is valid. Examples # checks if the customer is subscribed to a product on the default plan Bling.Customers . subscribed_to_product? ( customer , &quot;prod_123&quot; ) # checks if the customer is subscribed to a product on a specific plan Bling.Customers . subscribed_to_product? ( customer , &quot;prod_123&quot; , plan : &quot;pro&quot; )","ref":"Bling.Customers.html#subscribed_to_product?/3","title":"Bling.Customers.subscribed_to_product?/3","type":"function"},{"doc":"Fetches a single subscription for a customer by plan name. Examples # gets subscription with name &quot;default&quot; subscription = Bling.Customers . subscription ( customer ) # gets subscription with specific name subscription = Bling.Customers . subscription ( customer , plan : &quot;pro&quot; )","ref":"Bling.Customers.html#subscription/2","title":"Bling.Customers.subscription/2","type":"function"},{"doc":"Creates and returns a url to make a new subscription using stripe checkout. Examples url = subscription_checkout_url ( customer , plan : &quot;default&quot; , prices : [ { price_id , quantity } ] stripe : %{ cancel_url : &quot;http://localhost:4000/users/settings&quot; , success_url : &quot;http://localhost:4000/users/settings&quot; } )","ref":"Bling.Customers.html#subscription_checkout_url/2","title":"Bling.Customers.subscription_checkout_url/2","type":"function"},{"doc":"Fetches all subscriptions for a customer.","ref":"Bling.Customers.html#subscriptions/1","title":"Bling.Customers.subscriptions/1","type":"function"},{"doc":"Returns true if the customer is on a generic trial or if the specified subscription is on a trial. Examples # checks trial_ends_at on customer and &quot;default&quot; subscription plan Bling.Customers . trial? ( customer ) # checks trial_ends_at on customer and &quot;swimming&quot; subscription plan Bling.Customers . trial? ( customer , plan : &quot;swimming&quot; )","ref":"Bling.Customers.html#trial?/2","title":"Bling.Customers.trial?/2","type":"function"},{"doc":"Updates the customers default payment method with the provided payment_method_id.","ref":"Bling.Customers.html#update_default_payment_method/2","title":"Bling.Customers.update_default_payment_method/2","type":"function"},{"doc":"Updates the customer's default payment method with the one stored in stripe.","ref":"Bling.Customers.html#update_default_payment_method_from_stripe/1","title":"Bling.Customers.update_default_payment_method_from_stripe/1","type":"function"},{"doc":"A struct to normalize stripe sources.","ref":"Bling.PaymentMethod.html","title":"Bling.PaymentMethod","type":"module"},{"doc":"Given a stripe source, card, or payment method, returns a Bling.PaymentMethod struct or nil.","ref":"Bling.PaymentMethod.html#from_source/1","title":"Bling.PaymentMethod.from_source/1","type":"function"},{"doc":"","ref":"Bling.PaymentMethod.html#t:t/0","title":"Bling.PaymentMethod.t/0","type":"type"},{"doc":"Provides a macro to register the routes for Bling.","ref":"Bling.Router.html","title":"Bling.Router","type":"module"},{"doc":"Registers the routes for Bling. Defaults to a prefix of &quot;/billing&quot;. These routes are protected by the Bling.can_manage_billing? method of your MyApp.Bling module. The following routes are registered: GET /billing/:customer_type/:customer_id/finalize this is used to resolve payment issues, can be used as a stripe redirect or directly with a query string of ?payment_intent=pi_xxx or ?setup_intent=si_xxx POST /billing/:customer_type/:customer_id/payment-method this is used by the finalize route to update the customers payment method if required","ref":"Bling.Router.html#bling_routes/1","title":"Bling.Router.bling_routes/1","type":"macro"},{"doc":"Handles Stripe webhooks for: customer.deleted cancels all subscriptions and removes the payment method customer.updated updates the default payment method customer.subscription.created creates a new subscription and subscription items customer.subscription.updated updates the subscription customer.subscription.deleted cancels the subscription Additional events can be handled by implementing the handle_stripe_webhook_event/1 function in your Bling module. Usage Register this module before the Parsers plug in your endpoint.ex file: defmodule MyAppWeb.Endpoint do # ... # this MUST be added right BEFORE the parser plug Stripe.WebhookPlug , at : &quot;/webhooks/stripe&quot; , handler : Bling.StripeWebhookHandler , secret : { Application , :get_env , [ :stripity_stripe , :webhook_secret ] } # this should already be present plug Plug.Parsers , parsers : [ :urlencoded , :multipart , :json ] , pass : [ &quot;*/*&quot; ] , json_decoder : Phoenix . json_library ( ) Your config should have a webhook_secret key as well: config :stripity_stripe , api_key : &quot;...&quot; , public_key : &quot;...&quot; , webhook_secret : &quot;...&quot;","ref":"Bling.StripeWebhookHandler.html","title":"Bling.StripeWebhookHandler","type":"module"},{"doc":"","ref":"Bling.StripeWebhookHandler.html#handle_event/1","title":"Bling.StripeWebhookHandler.handle_event/1","type":"function"},{"doc":"Module to interact with Bling subscriptions. Most functions expect the ecto subscription struct as the first argument, and will return the updated subscription with subscription items preloaded.","ref":"Bling.Subscriptions.html","title":"Bling.Subscriptions","type":"module"},{"doc":"Returns whether the provided subscription is active, which is if it has not ended, and it has a valid status.","ref":"Bling.Subscriptions.html#active?/1","title":"Bling.Subscriptions.active?/1","type":"function"},{"doc":"Adds prices to an existing subscription. Returns the subscription with the items loaded. Examples add_prices ( subscription , prices : [ { price_id , quantity } ] )","ref":"Bling.Subscriptions.html#add_prices/2","title":"Bling.Subscriptions.add_prices/2","type":"function"},{"doc":"Fetches the stripe subscription object from a database subscription.","ref":"Bling.Subscriptions.html#as_stripe_subscription/1","title":"Bling.Subscriptions.as_stripe_subscription/1","type":"function"},{"doc":"Cancels the subscription in stripe and updates the model. Cancellation is scheduled for the end of the period. If the user is on a trial, they will have until the end of their trial. Examples subscription = cancel ( subscription ) # can pass any valid Stripe.Subscription.update/2 params subscription = cancel ( subscription , stripe : %{ prorate : false } )","ref":"Bling.Subscriptions.html#cancel/2","title":"Bling.Subscriptions.cancel/2","type":"function"},{"doc":"Cancels a subscription at a specific time. Examples subscription = cancel_at ( subscription , DateTime . utc_now ( ) |&gt; DateTime . add ( 30 , :day ) ) # can pass any valid Stripe.Subscription.update/2 params subscription = cancel_at ( subscription , DateTime . utc_now ( ) |&gt; DateTime . add ( 30 , :day ) , stripe : %{ prorate : false } )","ref":"Bling.Subscriptions.html#cancel_at/3","title":"Bling.Subscriptions.cancel_at/3","type":"function"},{"doc":"Cancels and ends the subscription immediately. Examples subscription = cancel_now ( subscription ) # can pass any valid Stripe.Subscription.delete/2 params subscription = cancel_now ( subscription , stripe : %{ invoice_now : true } )","ref":"Bling.Subscriptions.html#cancel_now/2","title":"Bling.Subscriptions.cancel_now/2","type":"function"},{"doc":"Cancels, ends, and invoices for the subscription immediately. Forwards any stripe options to Bling.Subscriptions.cancel_now/2.","ref":"Bling.Subscriptions.html#cancel_now_and_invoice/2","title":"Bling.Subscriptions.cancel_now_and_invoice/2","type":"function"},{"doc":"Returns whether the provided subscription has been cancelled.","ref":"Bling.Subscriptions.html#canceled?/1","title":"Bling.Subscriptions.canceled?/1","type":"function"},{"doc":"Changes the subscription to new prices. Examples change_prices ( sub , prices : [ { price_id , quantity } ] )","ref":"Bling.Subscriptions.html#change_prices/2","title":"Bling.Subscriptions.change_prices/2","type":"function"},{"doc":"Decrements the quantity of a subscription item. Defaults to decrementing the first item. Defaults to decrementing by one. Raises if trying to go below 0. ## Examples # this would update the first subscription item&#39;s quantity by one # useful for single price subscriptions subscription = decrement ( subscription ) # you can also specify a price and quantity to decrement by subscription = decrement ( subscription , price_id : &quot;price_123&quot; , quantity : 2 ) # can pass any valid Stripe.SubscriptionItem.update/2 params subscription = decrement ( subscription , stripe : %{ prorate : false } )","ref":"Bling.Subscriptions.html#decrement/2","title":"Bling.Subscriptions.decrement/2","type":"function"},{"doc":"Deletes the subscription from the database as well as cancels it in stripe. Examples subscription = delete ( subscription ) # can pass any valid Stripe.Subscription.delete/2 params subscription = delete ( subscription , stripe : %{ invoice_now : true } )","ref":"Bling.Subscriptions.html#delete/2","title":"Bling.Subscriptions.delete/2","type":"function"},{"doc":"Returns whether the provided subscription has been cancelled and is no longer within its grace period.","ref":"Bling.Subscriptions.html#ended?/1","title":"Bling.Subscriptions.ended?/1","type":"function"},{"doc":"Returns whether the provided subcription has been cancelled but has time before it ends.","ref":"Bling.Subscriptions.html#grace_period?/1","title":"Bling.Subscriptions.grace_period?/1","type":"function"},{"doc":"Returns whether the provided subscription has multiple subscription items (prices).","ref":"Bling.Subscriptions.html#has_multiple_prices?/1","title":"Bling.Subscriptions.has_multiple_prices?/1","type":"function"},{"doc":"Returns whether the provided subscription has only a single subscription item (price).","ref":"Bling.Subscriptions.html#has_single_price?/1","title":"Bling.Subscriptions.has_single_price?/1","type":"function"},{"doc":"Increments the quantity of a subscription item. Defaults to incrementing the first item. Defaults to incrementing by one. Examples # this would update the first subscription item&#39;s quantity by one # useful for single price subscriptions subscription = increment ( subscription ) # you can also specify a price and quantity to increment by subscription = increment ( subscription , price_id : &quot;price_123&quot; , quantity : 2 ) # can pass any valid Stripe.SubscriptionItem.update/2 params subscription = increment ( subscription , stripe : %{ prorate : false } )","ref":"Bling.Subscriptions.html#increment/2","title":"Bling.Subscriptions.increment/2","type":"function"},{"doc":"Returns whether the provided subscription is recurring, which is the case if it has no end date and is not on a trial.","ref":"Bling.Subscriptions.html#recurring?/1","title":"Bling.Subscriptions.recurring?/1","type":"function"},{"doc":"Removes prices from a subscription. Returns the subscription with the items loaded. Raises if all prices are removed from a subscription. Examples remove_prices ( subscription , prices : [ price_id ] )","ref":"Bling.Subscriptions.html#remove_prices/2","title":"Bling.Subscriptions.remove_prices/2","type":"function"},{"doc":"Resumes a cancelled subscription. The grace period must not have ended in order for this to succeed. Examples subscription = resume ( subscription ) # can pass any valid Stripe.Subscription.update/2 params subscription = resume ( subscription , stripe : %{ prorate : false } )","ref":"Bling.Subscriptions.html#resume/2","title":"Bling.Subscriptions.resume/2","type":"function"},{"doc":"Sets the quantity of a subscription item. Defaults to setting the first item. Defaults to setting to one. Examples # this would update the first subscription item&#39;s quantity to one # useful for single price subscriptions subscription = set_quantity ( subscription ) # you can also specify a price and quantity to set to subscription = set_quantity ( subscription , price_id : &quot;price_123&quot; , quantity : 2 ) # can pass any valid Stripe.SubscriptionItem.update/2 params subscription = set_quantity ( subscription , stripe : %{ prorate : false } )","ref":"Bling.Subscriptions.html#set_quantity/2","title":"Bling.Subscriptions.set_quantity/2","type":"function"},{"doc":"Turns an array of stripe subscription items into database subscription structs. Meant for internal use. Examples subscription = subscription_struct_from_stripe_subscription ( MyApp.Subscriptions.Subscription , stripe_subscription ) |&gt; MyApp.Repo . insert ( ) subscription_items = subscription_item_structs_from_stripe_items ( stripe_subscription . items . data , subscription ) |&gt; Enum . each ( &amp; MyApp.Repo . insert / 1 )","ref":"Bling.Subscriptions.html#subscription_item_structs_from_stripe_items/2","title":"Bling.Subscriptions.subscription_item_structs_from_stripe_items/2","type":"function"},{"doc":"Returns all of the database subscription items for a subscription.","ref":"Bling.Subscriptions.html#subscription_items/1","title":"Bling.Subscriptions.subscription_items/1","type":"function"},{"doc":"Turns a stripe subscription object into a database subscription without committing it. Meant for internal use. Examples subscription = subscription_struct_from_stripe_subscription ( MyApp.Subscriptions.Subscription , stripe_subscription ) |&gt; MyApp.Repo . insert ( )","ref":"Bling.Subscriptions.html#subscription_struct_from_stripe_subscription/2","title":"Bling.Subscriptions.subscription_struct_from_stripe_subscription/2","type":"function"},{"doc":"Returns whether the provided subscription is on a trial that hasn't expired.","ref":"Bling.Subscriptions.html#trial?/1","title":"Bling.Subscriptions.trial?/1","type":"function"},{"doc":"Returns whether the provided subscription is valid, which is the case if any of the following checks are true: Bling.Subscriptions.active?/1 Bling.Subscriptions.trial?/1 Bling.Subscriptions.grace_period?/1","ref":"Bling.Subscriptions.html#valid?/1","title":"Bling.Subscriptions.valid?/1","type":"function"},{"doc":"Copies the required assets for the billing page.","ref":"Mix.Tasks.Bling.Assets.html","title":"Mix.Tasks.Bling.Assets","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Bling.Assets.html#run/1","title":"Mix.Tasks.Bling.Assets.run/1","type":"function"},{"doc":"This task creates a migration to add the required customer columns to an existing table. Usage mix bling . customer &lt; table &gt; mix bling . customer users mix bling . customer teams","ref":"Mix.Tasks.Bling.Customer.html","title":"Mix.Tasks.Bling.Customer","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Bling.Customer.html#run/1","title":"Mix.Tasks.Bling.Customer.run/1","type":"function"},{"doc":"Copies the required files to use the bling package. It should only ever be ran once. Usage mix bling . install","ref":"Mix.Tasks.Bling.Install.html","title":"Mix.Tasks.Bling.Install","type":"task"},{"doc":"Callback implementation for Mix.Task.run/1 .","ref":"Mix.Tasks.Bling.Install.html#run/1","title":"Mix.Tasks.Bling.Install.run/1","type":"function"},{"doc":"If you'd like a ready-to-go interface for adding subscriptions to your Phoenix applications, check out the paid product Bankroll which is built on top of this library. Bling gives you an easy way to manage common billing scenarios in your own phoenix app through Stripe, making it a breeze to build custom subscription flows. This package is almost entirely headless, meaning you are free to implement your subscription management interface however you please. Instead of a prebuilt UI, it provides schemas and functions to handle these common scenarios: Creating subscriptions Changing plans Cancelling &amp; resuming Subscription trials Multiple subscriptions per customer Subscriptions with quantities (per-seat) Checking subscription status Is the subscription active? Is it on a trial? Is it still on the grace period? etc Saving customers default payment method Using any ecto schema as a customer (user, team, etc) Responding to failed payment attempts Responding to webhooks An isolated payment resolution page If a subscription payment fails or needs authentication, you can direct your users here to fix the issues on their own If setting up a payment method that requires a page redirection, you can redirect to this page to handle the result automatically This package is influenced heavily by the amazing Laravel Cashier . stripity_stripe is used under the hood, so most functions accept a stripe: %{} parameter that is passed directly to the underlying Stripe.*.* function allowing you to override options as needed.","ref":"readme.html","title":"Bling","type":"extras"},{"doc":"Installation Deploying Bling module The &quot;finalize&quot; route Customers Registering customer entities Payment methods Subscriptions Creating subscriptions Subscription quantities Trial periods Multiple subscriptions Changing prices/plans Cancelling &amp; resuming Checking subscription status Webhooks Payment failure notifications","ref":"readme.html#table-of-contents","title":"Bling - Table of Contents","type":"extras"},{"doc":"Note: Until Bling reaches 1.0.0 , breaking changes will be pushed as minor version bumps. Make sure to pin the dependency to ~&gt; 0.x.0 to ensure you only get patch releases. Add the module to your dependencies: def deps do [ { :bling , &quot;~&gt; 0.3.0&quot; } , { :stripity_stripe , &quot;~&gt; 2.17&quot; } ] end Configure stripe: config :stripity_stripe , api_key : &quot;...&quot; , public_key : &quot;...&quot; , webhook_secret : &quot;...&quot; Run the install task. This will generate: A migration creating the &quot;subscriptions&quot; and &quot;subscription_items&quot; tables Subscription/SubscriptionItem schema's Bling module StripeWebhookHandler Assets mix bling.install Create a migration to add the required columns to your customer table. The command in the example below uses the &quot;users&quot; table but you could use anything, like &quot;teams&quot;. mix bling.customer users Once the migration has been ran we can add the following to the corresponding module for the table we provided to the previous command: defmodule MyApp.Accounts.User do # ... schema &quot;users&quot; do # ... field :stripe_id , :string field :trial_ends_at , :utc_datetime field :payment_type , :string field :payment_id , :string field :payment_last_four , :string has_many :subscriptions , MyApp.Subscriptions.Subscription , foreign_key : :customer_id , where : [ customer_type : &quot;user&quot; ] , defaults : [ customer_type : &quot;user&quot; ] end end We can then register all of our generated modules in the config: config :bling , bling : MyApp.Bling , repo : MyApp.Repo , customers : [ user : MyApp.Accounts.User ] , subscription : MyApp.Subscriptions.Subscription , subscription_item : MyApp.Subscriptions.SubscriptionItem We must enable route helpers: defmodule MyAppWeb do # ... def router do quote do use Phoenix.Router , helpers : true # ... Open up your router file and add the Bling routes. The bling_routes/1 macro registers two routes: GET /billing/:customer_type/:customer_id/finalize - used to resolve payment and setup issues POST /billing/:customer_type/:customer_id/payment-method - used to save a payment method to a customer, used by the finalize page You can optionally pass a prefix to this macro to use instead of /billing : defmodule MyAppWeb.Router do import Bling.Router # ... your routes # create this scope separate from all of your other routes scope &quot;/&quot; do # make sure to authenticate your users for this route pipe_through [ :browser , :require_authenticated_user ] bling_routes ( ) end end Open up your endpoint file and add the stripe webhook handler: defmodule MyAppWeb.Endpoint do # ... # this MUST be added right BEFORE the parser plug Stripe.WebhookPlug , at : &quot;/webhooks/stripe&quot; , handler : Bling.StripeWebhookHandler , secret : { Application , :get_env , [ :stripity_stripe , :webhook_secret ] } # this should already be present plug Plug.Parsers , parsers : [ :urlencoded , :multipart , :json ] , pass : [ &quot;*/*&quot; ] , json_decoder : Phoenix . json_library ( ) Don't forget to register your endpoint in stripe webhook's dashboard to &quot;/webhooks/stripe&quot; and at least the following events: customer.deleted customer.updated customer.subscription.created customer.subscription.updated customer.subscription.deleted invoice.payment_action_required invoice.payment.failed That is all! Read on to learn how to use everything.","ref":"readme.html#installation","title":"Bling - Installation","type":"extras"},{"doc":"The mix bling.install command should only be ran once. When you are deploying, you should either commit the assets in priv/static/assets/bling or run the mix bling.assets command during deployment to ensure the required js/css is present.","ref":"readme.html#deploying","title":"Bling - Deploying","type":"extras"},{"doc":"The Bling module has a few helpful methods for deriving information: MyApp.Accounts.User = Bling . module_from_customer_type ( &quot;user&quot; ) &quot;user&quot; = Bling . customer_type_from_struct ( % MyApp.Accounts.User { } ) # queries the registered customer modules for a matching stripe_id % MyApp.Accounts.User { } = Bling . customer_from_stripe_id ( &quot;cus_1234&quot; )","ref":"readme.html#bling-module","title":"Bling - Bling module","type":"extras"},{"doc":"You can should also implement these methods in your MyApp.Bling module to extend functionality: def to_stripe_params(customer) return a map of valid Stripe.Customer.create/2 params to create/update the customer with. def tax_rate_ids(customer) return a list of tax rate ids as strings to apply to new subscriptions on a per-customer basis. def handle_stripe_webhook_event(%Stripe.Event{} = event) handle your own stripe webhook events. def can_manage_billing?(conn, customer) return true if the current user (derive it yourself from conn ) can access the billing routes for the given customer .","ref":"readme.html#project-bling-module","title":"Bling - Project Bling module","type":"extras"},{"doc":"The finalize route is used to resolve payment and setup issues. It was registered during the installation steps above. When creating a subscription or setting up a payment method you can use this route as a redirect URL and Stripe will automatically add the proper query params. You can also use this yourself, if you are sending payment failure emails, for example. Make sure to include a ?payment_intent=pi_xxx or ?setup_intent=si_xxx in the query string as it will use that to determine how to handle the situation. If it's a payment intent, it will: show a success message if status = succeeded confirm the payment if status = incomplete prompt the user to update their payment method if status = requires_payment_method handle further authentication if status = requires_action If it's a setup intent, it will: show a success message if status = succeeded prompt the user to update their payment method if status = requires_payment_method handle further authentication if status = requires_action This page by default does not allow anyone to view it. Make sure to configure the can_manage_billing?/2 function in your MyApp.Bling module to return true for the current user. See the &quot;Bling module&quot; section above for more information.","ref":"readme.html#the-finalize-route","title":"Bling - The &quot;finalize&quot; route","type":"extras"},{"doc":"Customers represent an entity that can have a subscription and a payment method. For reference on functions available to customer entities, see the Bling.Customers module docs. Registering a new customer entity Create a migration to add the required columns to your customer table. The command in the example below uses the &quot;users&quot; table but you could use anything, like &quot;teams&quot;. mix bling.customer users Once the migration has been ran we can add the following to the corresponding module for the table we provided to the previous command: defmodule MyApp.Accounts.User do # ... schema &quot;users&quot; do # ... field :stripe_id , :string field :trial_ends_at , :utc_datetime field :payment_type , :string field :payment_id , :string field :payment_last_four , :string has_many :subscriptions , MyApp.Subscriptions.Subscription , foreign_key : :customer_id , where : [ customer_type : &quot;user&quot; ] , defaults : [ customer_type : &quot;user&quot; ] end end We can then register this customer in our config: config :bling , customers : [ user : MyApp.Accounts.User ] That's it! Creating customers in stripe To create a customer in stripe from a customer entity: user = MyApp.Accounts . get ( 1 ) Bling.Customers . create_stripe_customer ( user ) This will merge with the data from the to_stripe_params/1 method in your Bling module if present. Payment methods A single payment method can be saved to the customer. The required columns were generated when you ran the mix bling.customer &lt;table&gt; command. Creating a payment method Customers can have a single payment method attached to them. To add a payment method, start by creating a setup intent: intent = Bling.Customers . create_setup_intent ( customer ) You'll then want to forward intent.client_secret to your frontend's payment element and collect their payment details. Upon submitting your setup form you can POST the payment method ID to the billing url to save it to the customer. The billing URL will depend on what you registered in your routes file and the customer type. const { error, setupIntent } = await stripe.confirmSetup({ elements, redirect: 'if_required', confirmParams: { // you can use the &quot;finalize&quot; route provided by Bling if you wish to let us handle this automatically // e.g. example.com/billing/user/1/finalize return_url: returnUrl, }, }); if (error) { // handle erro return; } const response = await fetch({ method: 'post', url: '/billing/user/1/payment-method', body: JSON.stringify({ payment_method_id: setupIntent.payment_method }), }); This payment method will be saved to the customer and used for future subscriptions. Updating payment method Follow the same steps as create. Getting the customers payment method # returns a Bling.PaymentMethod{} struct or nil Bling.Customers . default_payment_method ( customer )","ref":"readme.html#customers","title":"Bling - Customers","type":"extras"},{"doc":"Creating subscriptions Creating subscriptions is a bit complex since it is a multi-step process on stripe's side. First, make sure your customer has a payment method configured as per Payment Methods above. Then we need to fetch the customer and attempt to create the subscription for them. It will create the subscription in stripe, which in return gives us a payment intent. We then attempt to confirm the payment intent. If that succeeds, we're good to go. If it doesn't, we have to handle the error appropriately to ensure the subscription gets activated. Below is an example of how to deal with this: customer = MyApp.Accounts . get ( 1 ) # you can use your own url but we provide # a ready to go url to handle payment failures return_url = url ( ~p&quot;/billing/user/1/finalize&quot; ) result = Bling.Customers . create_subscription ( customer , return_url : return_url , prices : [ { price_id , quantity } ] , stripe : %{ coupon : &quot;coupon_id&quot; } , # any valid `Stripe.Subscription.create` params ) case result do { :ok , subscription } -&gt; # success, returns the created ecto subscription { :requires_action , payment_intent } -&gt; # payment requires further authentication # pass payment_intent.client_secret to your frontend # to finish resolving with stripe.js `handleNextAction` method { :error , error } -&gt; # error is %Stripe.Error{}, card could have been declined # pass error.user_message to frontend end It is important to handle these scenarios. If the subscription error's or requires action, you will be left with a subscription with a status of incomplete in your database. Stripe will leave these open for 24h before closing them, which will trigger a webhook event, which will delete it from your database. Most billing scenarios only have a single price, but if yours has multiple you can pass multiple prices to the prices list: Bling.Customers . create_subscription ( customer , return_url : finalize_url , prices : [ { &quot;price_base&quot; , 1 } , { &quot;price_support&quot; , 1 } ] , ) Tax rates You can configure which tax rates automatically apply to subscriptions by implementing the tax_rate_ids/1 method in your Bling module. It should return a list of string tax rate ids for the given customer: defmodule MyApp.Bling do # ... def tax_rate_ids ( % MyApp.Accounts.User { } = _customer ) , do : [ &quot;tax_rate_user_id&quot; ] def tax_rate_ids ( % MyApp.Accounts.Team { } = _customer ) , do : [ &quot;tax_rate_company_id&quot; ] def tax_rate_ids ( _customer ) , do : [ ] end Subscription quantities You can specify an initial quantity when creating the subscription, but if you are charging &quot;per seat&quot; you will need to change the quantity at some point. By default we update the quantity by one. If the subscription only has a single price, you don't need to pass an ID. Note: if you try to decrement below 0 you will get an error. Instead, use the cancel method if you are working with a single price, or change_prices if working with multiple. Bling.Subscriptions . increment ( subscription ) Bling.Subscriptions . decrement ( subscription ) You can change how much to increment/decrement by: Bling.Subscriptions . increment ( subscription , quantity : 5 ) If you have multiple prices you must specify a price_id: Bling.Subscriptions . increment ( subscription , price_id : &quot;price_projects&quot; , ) If you'd like to specify a specific quantity, you can use the set_quantity method: Bling.Subscriptions . set_quantity ( subscription , price_id : &quot;price_123&quot; , quantity : 2 ) All of these methods also take an optional stripe config that matches the Stripe.SubscriptionItem.update method: Bling.Subscriptions . set_quantity ( subscription , price_id : &quot;price_123&quot; , quantity : 2 , stripe : %{ prorate : true } )","ref":"readme.html#subscriptions","title":"Bling - Subscriptions","type":"extras"},{"doc":"Trial periods can be configured by passing trial_end or trial_period_days as additional stripe config: Bling.Customers . create_subscription ( customer , return_url : finalize_url , prices : [ { price_id , quantity } ] , stripe : %{ trial_period_days : 7 } , ) You can check the status of a trial with these methods: Bling.Subscriptions . trial? ( subscription ) Bling.Customers . trial? ( customer ) # with explicit plan names Bling.Subscriptions . trial? ( subscription , plan : &quot;default&quot; ) Bling.Customers . trial? ( customer , plan : &quot;default&quot; )","ref":"readme.html#trial-periods","title":"Bling - Trial periods","type":"extras"},{"doc":"Also known as &quot;generic trials&quot;. When creating a subscription with a trial, it requires a payment method to be on the customer. If you'd like to give them a trial without first setting up a payment method, you can set the trial_ends_at property on the customer: ends_at = DateTime . utc_now ( ) |&gt; DateTime . add ( 7 , :day ) |&gt; DateTime . truncate ( :second ) customer = MyApp.Accounts . get_by! ( 1 ) customer |&gt; Ecto.Changeset . change ( %{ trial_ends_at : ends_at } ) |&gt; MyApp.Repo . update! ( ) You can then use the Customer.trial?/2 and Customer.generic_trial?/1 methods to check if the customer is on a trial. Customer.trial?/2 will check for a generic trial on the customer or if a customer has a subscription on a trial. Customer.generic_trial?/1 will only check the trial_ends_at on the customer. Multiple subscriptions By default, subscriptions are created under the hood with plan: &quot;default&quot; so applications with simple billing flows don't have to think about it. If your application allows customers to have multiple subscriptions, you can pass a plan parameter to give each one a name: Bling.Customers . create_subscription ( customer , return_url : finalize_url , prices : [ { price_id , quantity } ] , plan : &quot;swimming&quot; ) Then when fetching subscriptions, you can pass the plan name again as an argument: subscription = Bling.Customers . subscription ( customer , plan : &quot;swimming&quot; ) # also works for other methods Bling.Customers . subscribed? ( customer , plan : &quot;swimming&quot; ) Changing prices (plans) If your customer wishes to upgrade or downgrade their plan, you can simply change the price associated with the subscription: subscription = Bling.Customers . subscription ( customer ) Bling.Subscriptions . change_prices ( subscription , prices : [ { price_id , quantity } ] ) Everything in the prices list will act as the new &quot;truth&quot; for the subscription. Meaning, if your subscriptions only have a single price, you would simply put only the new price and quantity in this list. But if you have multiple prices in your subscription, you should make sure to keep the prices you want active in this list, add any new prices, and omit any prices you don't want active anymore. You can pass extra options to this method to e.g. configure proration: Bling.Subscriptions . change_prices ( subscription , prices : [ { price_id , quantity } ] , stripe : %{ prorate : true } ) Cancelling &amp; resuming Subscriptions can be cancelled using any of the cancel methods. If the subscription is currently on a trial, the subscription will be active until the end date of the trial, not the end of the billing period. # cancel at end of period Bling.Subscriptions . cancel ( subscription ) # cancel immediately Bling.Subscriptions . cancel_now ( subscription ) # cancel at a specific time Bling.Subscriptions . cancel_at ( subscription , DateTime . utc_now ( ) |&gt; DateTime . add ( 7 , :day ) ) Checking subscription status See Bling.Subscriptions for a full list. Common ones include: Bling.Subscriptions . active? ( subscription ) Bling.Subscriptions . trial? ( subscription ) Bling.Subscriptions . grace_period? ( subscription ) Bling.Subscriptions . ended? ( subscription )","ref":"readme.html#no-card-upfront-trials","title":"Bling - No card upfront trials","type":"extras"},{"doc":"During the installation step you installed a stripe webhook handler. This takes care of responding to some events like subscription creation and updating, which are required to use some of the methods provided by this library. If you want to handle additional events, you can do that in the Bling module. We recommend handling these two events to notify your customers that there was an issue with their payment. You can send them to the finalize url with a ?payment_intent=the-payment-intent-id query string so they can resolve the issues on their own, or you can handle it another way: defmodule MyApp.Bling do def handle_stripe_webhook_event ( % Stripe.Event { } = event ) do case event . type do &quot;invoice.payment_action_required&quot; -&gt; # todo: send email nil &quot;invoice.payment.failed&quot; -&gt; # todo: send email nil _ -&gt; nil end :ok end end","ref":"readme.html#webhooks","title":"Bling - Webhooks","type":"extras"},{"doc":"You likely want to notify your customers when their payment fails. Luckily it's easy with Bling! The &quot;Webhooks&quot; section above explained how to respond to webhooks, we'll build off of that to send the email when Stripe notifies of us an issue. Open up your bling.ex file: Note: You may need to derive your customers email differently than the example here. defmodule MyApp.Bling do # ... def handle_stripe_webhook_event ( % Stripe.Event { } = event ) do case event . type do &quot;invoice.payment_action_required&quot; -&gt; send_payment_failure_email ( event . data . object ) &quot;invoice.payment.failed&quot; -&gt; send_payment_failure_email ( event . data . object ) _ -&gt; nil end :ok end defp send_payment_failure_email ( % Stripe.Invoice { } = invoice ) do customer = Demo.Bling . customer_from_stripe_id ( invoice . customer ) type = Demo.Bling . customer_type_from_struct ( customer ) finalize_url = url ( ~p&quot;/billing/ \#{ type } / \#{ customer . id } /finalize?payment_intent= \#{ invoice . payment_intent } &quot; ) email_body = &quot;&quot;&quot; Your payment method requires additional action in order to proceed. Please visit the following link to resolve this issue to ensure your subscription remains active: \#{ finalize_url } &quot;&quot;&quot; import Swoosh.Email new ( ) |&gt; to ( customer . email ) |&gt; from ( { &quot;MyApp&quot; , &quot;contact@example.com&quot; } ) |&gt; subject ( &quot;[Action Required] We failed to process your last payment&quot; ) |&gt; text_body ( email_body ) |&gt; MyApp.Mailer . deliver ( ) :ok end end","ref":"readme.html#payment-failure-notifications","title":"Bling - Payment failure notifications","type":"extras"},{"doc":"Contributions are always welcome. Please open issues and submit pull requests with proper tests included. Running tests The tests require you to have a config/test.secret.exs file setup. It should look like: import Config config :stripity_stripe , api_key : &quot;&quot; config :bling , ecto_repos : [ BlingTest.Repo ] config :bling , BlingTest.Repo , username : &quot;postgres&quot; , password : &quot;postgres&quot; , database : &quot;bling_test&quot; , hostname : &quot;localhost&quot; , pool : Ecto.Adapters.SQL.Sandbox config :bling , products : [ pro : &quot;prod_123&quot; , plus : &quot;prod_456&quot; ] , prices : [ plus_monthly : &quot;price_123&quot; , plus_yearly : &quot;price_456&quot; , pro_monthly : &quot;price_789&quot; , pro_yearly : &quot;price_abc&quot; ] You can use the provided docker container for the test database: docker compose up -d The tests hit the real Stripe api so make sure to enter a test api key. This also means the tests may take a bit to run. You will need two products in stripe, each with monthly and yearly prices. The names of them do not matter, we called them plus/pro, but enter them appropriately into the config above.","ref":"readme.html#contributing","title":"Bling - Contributing","type":"extras"}]